########################################################################
#	IntensiveScan.py
#
#	Intensive Scan v0.2 updated by USS Sovereign -- 01/10/2005
#	v0.3 updated by CaptainKeyes -- 01/10/2005
#	v0.3.1 updated by USS Sovereign -- 01/10/2005
#	v0.3.2 updated by CaptainKeyes -- 01/10/2005
#	v0.3.3 updated by USS Sovereign -- 01/10/2005
#
#	Authors: BCS: TNG
#
#	Description: Well since we are BCS: TNG I can work on 
#	other people's mods, well other team members mods :)
#	I love the idea of this mod and it is needed in BC.
#	There was a stall on this mod, now we are good to go.
#	This mod forces enemy ships to decloak when the scan
#	is complete.
#	NOTE TO BCS: TNG I'm your God lol
#
#	Credits: BCS: TNG for this script and Defiant for 
#	qbautostart
#
#	Permissions: Ask before modifying, we will haunt you if
#	you don't ask for permission!!!
########################################################################

# Globals and Imports
import App
import Lib.LibEngineering
import MissionLib
pButtonCS = None
pButtonTS = None
pButtonAPS = None
pButtonSS = None
pMenu = None

# Get the menu and buttons :)
def init():
	global pButtonCS, pButtonTS, pButtonAPS, pButtonSS, pMenu
        pMiguelMenu = Lib.LibEngineering.GetBridgeMenu("Science")

        pMenu = App.STMenu_CreateW(App.TGString("Intensive Scans"))
        pMiguelMenu.PrependChild(pMenu)

        pButtonSS = Lib.LibEngineering.CreateMenuButton("Intensive Scan - Distortion", "Science", __name__ + ".DistortionScan", ToButton = pMenu)
        pButtonCS = Lib.LibEngineering.CreateMenuButton("Intensive Scan - Chroniton", "Science", __name__ + ".ChronitonScan", ToButton = pMenu)
        pButtonTS = Lib.LibEngineering.CreateMenuButton("Intensive Scan - Tachyon", "Science", __name__ + ".TachyonScan", ToButton = pMenu)
        pButtonAPS = Lib.LibEngineering.CreateMenuButton("Intensive Scan - Antiproton", "Science", __name__ + ".AntiprotonScan", ToButton = pMenu)


# Well a few things are changed over here basically this is Cpt's work
def DistortionScan(pObject, pEvent):
        pButtonCS.SetDisabled()
        pButtonTS.SetDisabled()
        pButtonAPS.SetDisabled()
        pButtonSS.SetDisabled()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "DS", None, 0, Database))
	pSequence.Play()
        pStandardTimer = MissionLib.CreateTimer(Lib.LibEngineering.GetEngineeringNextEventType(), __name__ + ".DistortionScanTimer", App.g_kUtopiaModule.GetGameTime() + 4, 0, 0) 
	print "Starting Distortion Scan"
	
# Same as Distortion Scan	
def ChronitonScan(pObject, pEvent):
        pButtonCS.SetDisabled()
        pButtonTS.SetDisabled()
        pButtonAPS.SetDisabled()
        pButtonSS.SetDisabled()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "CS", None, 0, Database))
	pSequence.Play()
	pChronitonTimer = MissionLib.CreateTimer(Lib.LibEngineering.GetEngineeringNextEventType(), __name__ + ".ChronitonScanTimer", App.g_kUtopiaModule.GetGameTime() + 6, 0, 0)
	print "Starting Chroniton Scan"

# Same as Distortion Scan	
def TachyonScan(pObject, pEvent):
        pButtonCS.SetDisabled()
        pButtonTS.SetDisabled()
        pButtonAPS.SetDisabled()
        pButtonSS.SetDisabled()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "TS", None, 0, Database))
	pSequence.Play()
        pTachyonTimer = MissionLib.CreateTimer(Lib.LibEngineering.GetEngineeringNextEventType(), __name__ + ".TachyonScanTimer", App.g_kUtopiaModule.GetGameTime() + 9, 0, 0)
	print "Starting Tachyon Scan"

# Same as Distortion Scan
def AntiprotonScan(pObject, pEvent):
        pButtonCS.SetDisabled()
        pButtonTS.SetDisabled()
        pButtonAPS.SetDisabled()
        pButtonSS.SetDisabled()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "AP", None, 0, Database))
	pSequence.Play()
        pAntiprotonTimer = MissionLib.CreateTimer(Lib.LibEngineering.GetEngineeringNextEventType(), __name__ + ".AntiprotonScanTimer", App.g_kUtopiaModule.GetGameTime() + 12, 0, 0)
	print "Starting AntiProton Scan"

# Now this is where a new code is added it orders enemy ship to decloak, hehe sneaky but the only way as far as 
# I know but with the timer it is very realistic
def DistortionScanTimer(pObject, pEvent):
        DSChance = App.g_kSystemWrapper.GetRandomNumber(99) + 1 
        DistortionChance = 15
        pGame = App.Game_GetCurrentGame()
	pEpisode = pGame.GetCurrentEpisode()
	pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pEnemyGroup = pMission.GetEnemyGroup()
	pEnemies = pMission.GetEnemyGroup()
	lpEnemies = pEnemyGroup.GetActiveObjectTupleInSet(pSet)
        if (DSChance < DistortionChance):
            for pEnemy in lpEnemies:
                pTargetattr	= App.ShipClass_Cast(pEnemy)
                if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
                    pCloakingDevice = pTargetattr.GetCloakingSubsystem()
                    if pCloakingDevice:
                        pCloakingDevice.StopCloaking()
                        print "Scanning Successful"
        else:
            print "Scanning Failed"


        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "ScanComplete", None, 0, Database))
	pSequence.Play()     
        pButtonCS.SetEnabled()
        pButtonTS.SetEnabled()
        pButtonAPS.SetEnabled()
        pButtonSS.SetEnabled()
        print "Distortion Scan Complete"

# Now this is where a new code is added it orders enemy ship to decloak, hehe sneaky but the only way as far as 
# I know but with the timer it is very realistic
def ChronitonScanTimer(pObject, pEvent):
        ChronitonChance = 35
        CSChance = App.g_kSystemWrapper.GetRandomNumber(99) + 1
	pGame = App.Game_GetCurrentGame()
	pEpisode = pGame.GetCurrentEpisode()
	pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pEnemyGroup = pMission.GetEnemyGroup()
	pEnemies = pMission.GetEnemyGroup()
	lpEnemies = pEnemyGroup.GetActiveObjectTupleInSet(pSet)

        if (CSChance < ChronitonChance):
            for pEnemy in lpEnemies:
                pTargetattr	= App.ShipClass_Cast(pEnemy)
                if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
                    pCloakingDevice = pTargetattr.GetCloakingSubsystem()
                    if pCloakingDevice:
                        pCloakingDevice.StopCloaking()
                        print "Scanning Succesful"
        else:
            print "Scanning failed"

        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "ScanComplete", None, 0, Database))
	pSequence.Play()     
        pButtonCS.SetEnabled()
        pButtonTS.SetEnabled()
        pButtonAPS.SetEnabled()
        pButtonSS.SetEnabled()
        print "Chroniton Scan Complete"

# Now this is where a new code is added it orders enemy ship to decloak, hehe sneaky but the only way as far as 
# I know but with the timer it is very realistic
def TachyonScanTimer(pObject, pEvent):
        TSChance = App.g_kSystemWrapper.GetRandomNumber(99) + 1
        TachyonChance = 50 
	pGame = App.Game_GetCurrentGame()
	pEpisode = pGame.GetCurrentEpisode()
	pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pEnemyGroup = pMission.GetEnemyGroup()
	pEnemies = pMission.GetEnemyGroup()
	lpEnemies = pEnemyGroup.GetActiveObjectTupleInSet(pSet)
        if (TSChance < TachyonChance):
            for pEnemy in lpEnemies:
                pTargetattr	= App.ShipClass_Cast(pEnemy)
                if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
                    pCloakingDevice = pTargetattr.GetCloakingSubsystem()
                    if pCloakingDevice:
                        pCloakingDevice.StopCloaking()
                        print "Scan Succesful"
        else:
            print "Scan Failed"

        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "ScanComplete", None, 0, Database))
	pSequence.Play()     
        pButtonCS.SetEnabled()
        pButtonTS.SetEnabled()
        pButtonAPS.SetEnabled()
        pButtonSS.SetEnabled()
        print "Tachyon Scan Complete"

# Now this is where a new code is added it orders enemy ship to decloak, hehe sneaky but the only way as far as 
# I know but with the timer it is very realistic
def AntiprotonScanTimer(pObject, pEvent):
        APChance = App.g_kSystemWrapper.GetRandomNumber(99) + 1
        AntiprotonChance = 75 
	pGame = App.Game_GetCurrentGame()
	pEpisode = pGame.GetCurrentEpisode()
	pMission = pEpisode.GetCurrentMission()
        pPlayer = MissionLib.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pEnemyGroup = pMission.GetEnemyGroup()
	pEnemies = pMission.GetEnemyGroup()
	lpEnemies = pEnemyGroup.GetActiveObjectTupleInSet(pSet)

        if (APChance < AntiprotonChance):
            for pEnemy in lpEnemies:
                pTargetattr	= App.ShipClass_Cast(pEnemy)
                if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
                    pCloakingDevice = pTargetattr.GetCloakingSubsystem()
                    if pCloakingDevice:
                        pCloakingDevice.StopCloaking()
                        print "Scan Succesful"
        else:
            print "Scan Failed"

        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        Database = pMission.SetDatabase("data/TGL/IntensiveScan.tgl")
        pSequence = App.TGSequence_Create()
        pSet = App.g_kSetManager.GetSet("bridge")
        pScience = App.CharacterClass_GetObject(pSet, "Science")
        pSequence.AppendAction(App.CharacterAction_Create(pScience, App.CharacterAction.AT_SAY_LINE, "ScanComplete", None, 0, Database))
	pSequence.Play()     
        pButtonCS.SetEnabled()
        pButtonTS.SetEnabled()
        pButtonAPS.SetEnabled()
        pButtonSS.SetEnabled()
        print "Antiproton Scan Complete"
	

# THE END! This brings the conclusion to our broadcast. 
# Bridge Commander Scripters: The New Generation signing out. Well at least me USS Sovereign :)
	

        
